package com.idea.buildManage.controller;

import com.github.pagehelper.PageInfo;
import com.idea.buildManage.dto.MnpBuildingDto;
import com.idea.buildManage.service.ParkRoomService;
import com.idea.buildManage.model.MnpBuilding;
import com.idea.buildManage.model.MnpBuildingExample;
import com.idea.buildManage.service.MnpBuildingService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.shiro.util.ShiroUtils;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Date;

/**
 * Created by pengyq on 2020.
 */
@Controller
@RequestMapping(value = "MnpBuildingController")
@Api(tags = "载体管理")
public class MnpBuildingController extends BaseController {

    //主表
    @Autowired
    private MnpBuildingService modelService;


    @PostMapping(value = "list", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, MnpBuildingDto model, DateTrans dt) {
        PageInfo<MnpBuildingDto> page = modelService.list(tablepar, model, dt);
        TableSplitResult<MnpBuildingDto> result = new TableSplitResult<MnpBuildingDto>(page.getPageNum(), page.getTotal(), page.getList());
        return result;
    }

    @Autowired
    private ParkRoomService parkRoomService;


    @PostMapping(value = "listAll", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listAll(MnpBuilding model, DateTrans dt) {
        return modelService.listAll(model, dt);
    }

    @PostMapping(value = "add", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(MnpBuilding record) {
        try {
            // 同一楼盘下 载体名称不能重复
            MnpBuildingExample mnpBuildingExample = new MnpBuildingExample();
            mnpBuildingExample.createCriteria().andBuildNumEqualTo(record.getBuildNum()).andDiscIdEqualTo(record.getDiscId());
            long count = modelService.countByExample(mnpBuildingExample);
            if (count > 0) {
                throw new RuntimeException(record.getBuildNum() + "已存在,请调整后重新添加!!!");
            }
            record.setCreatedId(ShiroUtils.getUser().getId());
            record.setCreatedAt(new Date());
            int result = modelService.insertSelective(record);
            return result(result);
        } catch (Exception e) {
            return error(e.getMessage());
        }
    }

    @PostMapping(value = "remove/{id}", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult remove(@PathVariable("id") String id) {
        int result = modelService.deleteByPrimaryKey(id);
        return result(result);
    }

    @PostMapping(value = "edit", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult editSave(MnpBuilding model) {
        int result = modelService.updateByPrimaryKeySelective(model);
        return result(result);
    }

    @PostMapping(value = "getById", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public MnpBuilding getById(String id) {
        return modelService.selectByPrimaryKey(id);
    }


    @PostMapping(value = "excelListAll", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object excelListAll(MnpBuildingDto model) {

        return modelService.excelListAll(model);
    }
}
