package com.idea.buildManage.controller;

import com.github.pagehelper.PageInfo;
import com.idea.buildManage.response.ParkFloorDiscRespson;
import com.idea.buildManage.model.ParkFloorDisc;
import com.idea.buildManage.service.ParkFloorDiscService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Date;

/**
 * Created by pengyq on 2020.
 */
@Controller
@RequestMapping(value = "ParkFloorDiscController")
@Api(value="楼盘分期管理")
public class ParkFloorDiscController extends BaseController {

    //主表
    @Autowired
    private ParkFloorDiscService modelService;


    @PostMapping(value = "list",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, ParkFloorDisc model, DateTrans dt){
        PageInfo<ParkFloorDisc> page= modelService.list(tablepar,model,dt);
        TableSplitResult<ParkFloorDisc> result = new TableSplitResult<ParkFloorDisc>(page.getPageNum(), page.getTotal(), page.getList());
        return  result;
    }

    @ApiOperation(value = "楼盘分期列表")
    @PostMapping(value = "listAll",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listAll(ParkFloorDisc model, DateTrans dt){
        return  modelService.listAll(model,dt);
    }

    @ApiOperation(value = "新增楼盘分期")
    @PostMapping(value = "add",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(ParkFloorDiscRespson record){
        record.setCreatedAt(new Date());
        int result = modelService.add(record);
        return result(result);
    }

    @ApiOperation(value = "删除楼盘分期")
    @PostMapping(value = "remove/{id}",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult remove(@PathVariable("id") String id){
        int result = modelService.deleteByPrimaryKey(id);
        return result(result);
    }

    @ApiOperation(value = "编辑楼盘分期")
    @PostMapping(value = "edit",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult editSave(ParkFloorDiscRespson model){
        model.setUpdatedAt(new Date());
        int result = modelService.edit(model);
        return result(result);
    }

    @ApiOperation(value = "根据id查询楼盘分期")
    @PostMapping(value = "getById",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public ParkFloorDiscRespson getById(String id) {
        return modelService.getById(id);
    }

    @ApiOperation(value = "楼盘分期分页")
    @PostMapping(value = "listByModel",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listByModel(Tablepar tablepar, ParkFloorDiscRespson model, DateTrans dt){
        PageInfo<ParkFloorDiscRespson> page= modelService.listByModel(tablepar,model,dt);
        TableSplitResult<ParkFloorDiscRespson> result = new TableSplitResult<ParkFloorDiscRespson>(page.getPageNum(), page.getTotal(), page.getList());
        return  result;
    }

}
